<template>
  <section v-if="options.length > 0" class="list-container">
    <EventOptionListItemTotal :user="user" :total="totalCost" @checkoutInitiated="onCheckoutInitiated"/>
    <EventOptionCreator v-if="user && user.isAdmin()" :event_id="event_id" @eventOptionAdded="handleEventOptionAdded"/>
    <EventOptionListItem
      v-for="option in options"
      :key="option.id"
      :option="option"
      :order="user_bookings.find((el) => { return el.id === option.id }).value"
      @input="handleInput"
    />
  </section>
  <section v-else class="list-container">
      <span>Увы! Билетов ещё нет.</span>
  </section>
</template>

<script>
  import EventOptionListItem from "./EventOptionListItem";
  import EventOptionListItemTotal from "./EventOptionListItemTotal";
  import EventOptionCreator from './admin/EventOptionCreator'
  export default {
    name: "EventOptionList",
    components: { EventOptionCreator, EventOptionListItem, EventOptionListItemTotal },
    props: ["event_id", "options", "user_bookings", "user"],
    methods: {
      handleInput(id, value) {
        this.$emit('input', id, value);
      },
      handleEventOptionAdded(event_id, option) {
        this.options.push(option);
        this.user_bookings.push({id: option.id, value: 0});
      },
      onCheckoutInitiated() {
        this.$emit('checkoutInitiated');
      }
    },
    computed: {
      totalCost() {
        let x = 0.0;
        for (let booking of this.user_bookings) {
          let option = this.options.find((el) => { return el.id === booking.id })
          x += booking.value * option.price;
        }
        return x;
      }
    }
  }
</script>

<style scoped>

</style>
